// VoiceRec_com2.cpp:      .
//

#include "stdafx.h"
#include "pxcvoice.h"
#include "util_capture_file.h"

//   
class MyHandler : public PXCVoiceRecognition::Recognition::Handler{
public:
  virtual void PXCAPI OnRecognized(PXCVoiceRecognition::Recognition *data) {
    wprintf_s(L"\nRecognized: <%d>", data->label);   
  }
};

int wmain(int argc, wchar_t* argv[]){
  wprintf_s(L"Command mode without UtilPipeline");
  // 
  PXCSmartPtr<PXCSession> session; 
  PXCSession_Create(&session);

  //  
  PXCVoiceRecognition *vrec=0;
  session->CreateImpl<PXCVoiceRecognition>(&vrec);

  // 
  PXCVoiceRecognition::ProfileInfo pinfo;
  vrec->QueryProfile(0,&pinfo);
  UtilCapture capture(session);
  capture.LocateStreams(&pinfo.inputs);
  vrec->SetProfile(&pinfo);

  // 
  pxcUID gid = 0;
  vrec->CreateGrammar(&gid);
  vrec->AddGrammar(gid,1,L"One");
  vrec->AddGrammar(gid,2,L"Two");
  vrec->AddGrammar(gid,3,L"Three");
  vrec->SetGrammar(gid);

  vrec->SubscribeRecognition(0, new MyHandler); 
  
  //     
  PXCSmartPtr<PXCAudio> sample;
  PXCSmartSPArray sps(2);
  for(;;) {
   // Get samples from input device and pass to the module
   capture.ReadStreamAsync(sample.ReleaseRef(),sps.ReleaseRef(0));
   vrec->ProcessAudioAsync(sample,sps.ReleaseRef(1));
   sps.SynchronizeEx();
   wprintf_s(L".");
}
    
 return 0;

}


